#include "allegro.h"

unsigned char buffer[266879];

PACKFILE *f;
PACKFILE *out;

int inctr;

char filename[14];


typedef char C_TBL2_ENTRY[13];	

static char desc [11][255]=
{	"Chrono Trigger:\n999/999 hps,mps.\nFull inventory.\n8,350,000 GPS.\nMaximized stats(only if New Game+ is active.\nIf in battle, enemies HPs drop to 1!! Even BOSSES!!.\n Level up after getting 1 exp.\n)",
	"Secret Of Evermore:\nUps all stats to 9999. Useful for bosses.",
	"Lagoon.Ups all stats to 4096. Useful for bosses.",
	"Final Fantasy 5:\n9999/9999 hps,999/999 mps.\nFull inventory.\n9,999,999 GPS.\nInstant Level Up to 99 after 1 exp.\nInstant mastering of equipped class.",
	"Tales Of Phantasia:\n9999/9999 hps,999/999 ? tps\nFull inventory.",
	"Romancing Saga 1:\nFull Stats. 65534 money.",
	"Romancing Saga 3:\nFull Stats.\nMaximum weapon skills.\nUps Hps/Mps to max.",
	"Breath Of Fire 1:\nFull Stats. 8.35 million GPS. Straight to level 99.",
	"Breath Of Fire 2:\nFull Stats. 16.7 million GPS. Straight to level 99.",
	"Terranigma: Attack,Defense Power upped to maximum until level up.",
	"Final Fantasy 2:\nFull Stats. 100 percent hit rate.\n 9999/9999 hp, 999/999 mps."
};

extern void Chrono_Trigger();
extern void Secret_Of_Evermore();
extern void Lagoon();
extern void Final_Fantasy_5_e();
extern void Tales_Of_Phantasia();
extern void Romsaga_1();
extern void Romsaga_3();
extern void Breath_Of_Fire_1();
extern void Bfire_2();
extern void Terranigma();
extern void Final_Fantasy_2();

#define SNES_TBL_LEN 11

C_TBL2_ENTRY snes1[SNES_TBL_LEN]={
	"chrono",
        "evermore",
	"lagoon",
        "ff5e",
        "tales",
	"romsaga1",
	"romsaga3",
	"bfire",
        "brthof2",
	"terra",
	"ff2-us"
};


void usage()
{

printf("Hack v0.1\n");
printf(" Usage: Hack.exe [options] <game number> [slot] \n");
printf(" Current version only supports ZSNES save-hacking.\n");
printf("  Game numbers for SNES are:\n");

printf("   0     Chrono Trigger\n");
printf("   1     Secret of Evermore\n");
printf("   2     Lagoon\n");
printf("   3     Final Fantasy 5(english)\n");
printf("   4     Tales of Phantasia\n");
printf("   5     Romancing Saga 1\n");
printf("   6     Romancing Saga 3\n");
printf("   7     Breath of Fire 1\n");
printf("   8     Breath of Fire 2\n");
printf("   9     Terranigma\n");
printf("  10     Final Fantasy 2\n");

printf("\n Slot defaults to 0 if not specified.\n");
printf("\n Command line options:\n");
printf("\n -1        Information on the game specified.");

/*printf("\n -o [code] Not implemented yet. Will allow you to disable/enable options\n");
printf("           relating to the specified game.\n");*/

exit (0);

}


void rput16(unsigned short val,int offset)
{unsigned char *tmp;
 unsigned char t1,t2;
 tmp=(unsigned char *)&val;
 t1=*tmp;
 tmp+=1;
 t2=*tmp;

 buffer[offset]=t1;
 buffer[offset+1]=t2;
}               

void rput24(unsigned int val,int offset)
{unsigned char *tmp;
 unsigned char t1,t2,t3;
 tmp=(unsigned char *)&val;
 //tmp+=1;
 t1=*tmp;
 tmp+=1;
 t2=*tmp;
 tmp+=1;
 t3=*tmp;

 buffer[offset]=t1;
 buffer[offset+1]=t2;
 buffer[offset+2]=t3;
}

int main(int argc,char *argv[])
{signed int x;
int slot;
allegro_init();

if (argc==1)
usage();

chdir("snesnaps");

x=atoi(argv[1]);
if (x>SNES_TBL_LEN)
 {printf( " invalid game number.");
  exit(-255);}

if (argc>2)
 slot=atoi(argv[2]);
else
 slot=0;

if (x>-1)
{
strcpy(filename,snes1[x]);
filename[strlen(snes1[x])]='.';
filename[strlen(snes1[x])+1]='z';
filename[strlen(snes1[x])+2]='s';

if (slot==0)
 filename[strlen(snes1[x])+3]='t';
else
 filename[strlen(snes1[x])+3]=48+slot;

f=pack_fopen(filename,"r");

if (!f)
{printf ("You don't have the required snapshot: %s",filename);
exit(-255);}

inctr=0;

while (!pack_feof(f))
{buffer[inctr]=pack_getc(f); 
 inctr++;
}
pack_fclose(f);
}
switch (x)
 {    case -1:printf(desc[atoi(argv[2])]); chdir("../"); exit(0);

      case 0: Chrono_Trigger();
	      break;
      case 1: Secret_Of_Evermore();
	      break;
      case 2: Lagoon();
	      break;
      case 3: Final_Fantasy_5_e();
	      break;
      case 4: Tales_Of_Phantasia();
	      break;
      case 5: Romsaga_1();
	      break;
      case 6: Romsaga_3();
	      break;
      case 7: Breath_Of_Fire_1();
	      break;
      case 8: Bfire_2();
	      break;
      case 9: Terranigma();
	      break;
      case 10:Final_Fantasy_2();
	      break;

}

out=pack_fopen(filename,"w");

for (inctr=0;inctr<266879;inctr++)
{pack_putc(buffer[inctr],out);}

pack_fclose(out);

chdir("../");
}